Project
=======

This goal for this project is to enhance the bicycle light I have.

Stock bicycle light blinks, but it does not go on automatically - one has to push a button.

I want to add a motion sensor to it to enable it automatically whenever I start to ride the bicycle.


Goals
-----

* it has to work automatically
* no change to stock blink pattern
* make it low power
* replace the stock microcontroller
* it has to fit into the original enclosure
* because of that, all its parts have to be miniature


Analysis
--------

After reverse-engineering the light, it turned out it is quite simple:

* two AAA batteries, providing the power of 1.6 to 3V
* epoxy-blob microcontroller
* two set of lights, driven by simple transistor in switch mode
* one input button

<img src="original/lights_original_schem.png" width="500px" alt="original schematics">

The enclosure does not have too much space inside, but it is water-proof.
If I wanted to fit anything inside the enclosure, it has to be quite small.


### Modes ###

With every button press flash cycles through 4 modes:

1. constant off
2. constant on
3. trigger
4. flashes

While first two are obvious, the latter two must be described in detail.

![trigger pattern] (original/pattern-trigger.png)

![flashes pattern] (original/pattern-flashes.png)

Take a full period of 1.4s and break it down to 8 0.05s blocks.
Each set of LEDs can be on, off for the duration of a block, or flash quickly
(turn on for a time between 7 and 50 us, and then off until the end of block)

<table>
  <thead>
    <tr>
      <th>Mode
      <th>0
      <th>1
      <th>2
      <th>3
      <th>4
      <th>5
      <th>6
      <th>7
  </thead>
  <tr>
    <td rowspan=2>Off
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
  <tr>
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
    <td>0
  <tr>
    <td rowspan=2>On
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
  <tr>
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
    <td>1
  <tr>
    <td rowspan=2>Trigger
    <td>1
    <td>1
    <td>0
    <td>0
    <td>1
    <td>1
    <td>0
    <td>0
  <tr>
    <td>0
    <td>0
    <td>1
    <td>1
    <td>0
    <td>0
    <td>1
    <td>1
  <tr>
    <td rowspan=2>Flashes
    <td>f
    <td>0
    <td>f
    <td>1
    <td>0
    <td>1
    <td>0
    <td>f
  <tr>
    <td>1
    <td>0
    <td>f
    <td>f
    <td>f
    <td>f
    <td>0
    <td>0
</table>

Note that flashes pattern varies over the  different MCU starts (poweroff/poweron),
but are always has 0.4s period.


Implementation
--------------

In order to make it low-power, motion sensor has to be purely mechanical.
I decided to make it purely mechanical using a metal ball rolling inside a PCB box

![motion sensor] (motion_sensor/animation.gif)

The main challenge is that it has to quite small - merely 4.6mm thick.



Core of the project is [MSP430G2001](datasheets/msp430g2001.pdf).
It will be mounted on a single-ply copper clad board to make the height minimal.
Because of that, there will be no programming pins, just pads for spring pogo pins.

![schematics] (schematics.png)

